export interface Token {
    getKeyName(): string;
}
export declare class DefaultToken implements Token {
    name: string;
    static create(name: string): DefaultToken;
    getKeyName(): string;
}
export declare class TokenWithNamespace implements Token {
    namespace: string;
    name: string;
    getKeyName(): string;
}
export declare class Messenger {
    static readonly Default: Messenger;
    private observedMap;
    register<T extends Token = DefaultToken, M = any>(token: T, callback: (param: M) => void): void;
    send<T extends Token = DefaultToken, M = any>(token: T, message: M): void;
}
