var DefaultToken = /** @class */ (function () {
    function DefaultToken() {
        this.name = '';
    }
    DefaultToken.create = function (name) {
        var result = new DefaultToken();
        result.name = name;
        return result;
    };
    DefaultToken.prototype.getKeyName = function () {
        return this.name;
    };
    return DefaultToken;
}());
export { DefaultToken };
var TokenWithNamespace = /** @class */ (function () {
    function TokenWithNamespace() {
        this.namespace = '';
        this.name = '';
    }
    TokenWithNamespace.prototype.getKeyName = function () {
        return this.namespace + "_" + this.name;
    };
    return TokenWithNamespace;
}());
export { TokenWithNamespace };
var Messenger = /** @class */ (function () {
    function Messenger() {
        // tslint:disable-next-line:no-any
        this.observedMap = new Map();
    }
    // tslint:disable-next-line:no-any
    Messenger.prototype.register = function (token, callback) {
        var keyStr = token.getKeyName();
        var callbackArr = this.observedMap.get(keyStr);
        if (callbackArr) {
            callbackArr.push(callback);
        }
        else {
            var newArr = [callback];
            this.observedMap.set(keyStr, newArr);
        }
    };
    // tslint:disable-next-line:no-any
    Messenger.prototype.send = function (token, message) {
        var keyStr = token.getKeyName();
        var callbackArr = this.observedMap.get(keyStr);
        if (callbackArr) {
            callbackArr.forEach(function (callback) {
                callback(message);
            });
        }
    };
    Messenger.Default = new Messenger();
    return Messenger;
}());
export { Messenger };
//# sourceMappingURL=Messenger.js.map