var ObservableArray = /** @class */ (function () {
    function ObservableArray(proxiedArray) {
        this.proxiedArray = [];
        this.proxiedArray = proxiedArray || [];
    }
    Object.defineProperty(ObservableArray.prototype, "notifyCallBack", {
        get: function () {
            return this._notifyCallBack;
        },
        set: function (value) {
            this._notifyCallBack = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObservableArray.prototype, "length", {
        get: function () {
            return this.proxiedArray.length;
        },
        enumerable: true,
        configurable: true
    });
    ObservableArray.prototype.set = function (key, value) {
        this.proxiedArray[key] = value;
        if (this.notifyCallBack) {
            this.notifyCallBack(this.proxiedArray);
        }
    };
    ObservableArray.prototype.get = function (key, value) {
        return this.proxiedArray[key];
    };
    Object.defineProperty(ObservableArray.prototype, "originArray", {
        get: function () {
            return this.proxiedArray;
        },
        enumerable: true,
        configurable: true
    });
    ObservableArray.prototype.modifyArray = function (callback) {
        this.proxiedArray = callback(this.proxiedArray);
        if (this.notifyCallBack) {
            this.notifyCallBack(this.proxiedArray);
        }
    };
    return ObservableArray;
}());
export { ObservableArray };
//# sourceMappingURL=ObservableArray.js.map