var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
// import _ from 'lodash';
export var NotifyProperty = function (param) {
    if (param === void 0) { param = { isObservableArrayProperty: false }; }
    // tslint:disable-next-line:no-any
    return function (target, propertyKey, descriptor) {
        var setter = descriptor.set;
        var getter = descriptor.get;
        if (!getter) {
            throw new Error('Decorated property must have a getter.');
        }
        else {
            descriptor.get = function () {
                var _this = this;
                // tslint:disable-next-line:no-any
                var result = getter.call(this);
                if (param.isObservableArrayProperty && !result.notifyCallBack) {
                    // tslint:disable-next-line:no-any
                    result.notifyCallBack = function (array) {
                        _this.notifyValueChanged(propertyKey, array);
                    };
                }
                return result;
            };
        }
        if (setter) {
            // tslint:disable-next-line:no-any
            descriptor.set = function (value) {
                var _this = this;
                setter.call(this, value);
                this.notifyValueChanged(propertyKey, descriptor.value);
                if (param.isObservableArrayProperty) {
                    // tslint:disable-next-line:no-any
                    var result = getter.call(this);
                    if (!result.notifyCallBack) {
                        // tslint:disable-next-line:no-any
                        result.notifyCallBack = function (array) {
                            _this.notifyValueChanged(propertyKey, array);
                        };
                    }
                }
            };
        }
        else {
            throw new Error('Decorated property must have a setter.');
        }
    };
};
export function ConnetVVM(viewmodel) {
    // tslint:disable-next-line:no-any
    return function (target) {
        var original = target;
        // tslint:disable-next-line:no-any
        function construct(constructor, args) {
            // tslint:disable-next-line:no-any
            var c = function () {
                return constructor.apply(this, args);
            };
            c.prototype = constructor.prototype;
            return new c();
        }
        // tslint:disable-next-line:no-any
        var f = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = construct(original, args);
            result.viewmodel = viewmodel;
            viewmodel.view = result;
            return result;
        };
        f.prototype = original.prototype;
        return f;
    };
}
var ViewModelBase = /** @class */ (function () {
    function ViewModelBase() {
        this.noUpdate = false;
        this.dirtyObj = {};
    }
    ViewModelBase.prototype.notifyValueChanged = function (stateName, value) {
        if (this.noUpdate) {
            return;
        }
        else {
            Object.defineProperty(this.dirtyObj, stateName, {
                value: value,
            });
        }
        this.view.setState(__assign({}, this.view.state, { stateName: value }));
    };
    ViewModelBase.prototype.multiValueChanged = function (callback) {
        Object.assign(this.dirtyObj, {});
        this.noUpdate = true;
        callback();
        this.noUpdate = false;
        this.view.setState(__assign({}, this.view.state, this.dirtyObj));
    };
    return ViewModelBase;
}());
export { ViewModelBase };
//# sourceMappingURL=ViewModelBase.js.map